///////////////////////////////////////////////////////////////////////
//Verschlüsselung mit CatMap-Variante
//Vier verschiedene Transformationen hintereinander anwenden
//Danach Permutation der Bildpunkte
//Periodenbestimmung mit Multi-Threading
////////////////////////////////////////////////////////////
//Vier Matrizen zum Verschlüsseln, vier zum Entschlüsseln
//SecureRandom verwenden, um bessere Zufallszahlen zu erhalten
//////////////////////////////////////////////////////////////

import java.security.SecureRandom;


TransMatrix matrix1,matrix2,matrix3,matrix4,matrix5,matrix6,matrix7,matrix8;
PImage info, bild, bild1, bild2, bild3, bild4, bildV;//Verschiedene Bild-Stadien bei Ver-und Entschlüsselung
//So viele PImages sind nötig, damit jeder Thread aus seinem eigenen Bild lesen kann
PImage neuesBild1, neuesBild2, neuesBild3, neuesBild4, neuesBild5, neuesBild6,neuesBild7, neuesBild8 ;
PImage tmpBild;
int P1,P2,P3,P4;//Perioden
int N ;//Bildbreite
int n = 4000000; //damit Anzahl der Permutationen: 1 000 000
String[] permSchluessel ; 
int s1,t1,l1,s2,t2,l2,s3,t3,l3,s4,t4,l4,l1E,l2E,l3E,l4E;//Schlüssel
Table  schluesselV;//Ablage der Schlüssel
int[] werteV;//ausgelesene Schlüssel

SecureRandom randomGen = new SecureRandom();

void settings(){
   info =  loadImage("info.png");  
   bild = loadImage("text.png");  //wegen Mutlithreading viele PImages für text.png
   bild1 = loadImage("text.png");  
   bild2 = loadImage("text.png");  
   bild3 = loadImage("text.png");  
   bild4 = loadImage("text.png");  
   neuesBild1 = new PImage(N,N); 
   neuesBild2 = new PImage(N,N); 
   neuesBild3 = new PImage(N,N); 
   neuesBild4 = new PImage(N,N); 
   neuesBild5 = new PImage(N,N); 
   neuesBild6 = new PImage(N,N); 
   neuesBild7 = new PImage(N,N); 
   neuesBild8 = new PImage(N,N); 
   N = bild.width;
   P1=P2=P3=P4=0;//Initialisierung der Perioden
   schluesselV = new Table();//gibt csv-Datei für Verschlüsselung
   schluesselV.addColumn("zahl", Table.INT);//für csv-Datei
   size(N,N); 
}

void setup() { 
 image(info,0,0,N,N);
}

void draw () { 
  //braucht man, damit keyPressed() registriert wird
}

void keyPressed(){  
  if (key == 't'){
     image(bild,0,0);
  }
  
  if (key == 'v'){ //Verschlüsselung in vier Schritten   
    schluesselV = loadTable("schluesselV.csv", "header");  //Schlüssel auslesen 
    werteV = new int[schluesselV.getRowCount()];
    int i =0;
    for (TableRow row : schluesselV.rows()) {  
        int id = row.getInt("zahl");
        werteV[i] = id;
        i++;
    }
    //vier mal AT  
    s1 = werteV[0];  t1 = werteV[1];  l1 = werteV[2];   
    matrix1 = new TransMatrix(s1,t1,bild1,l1,N);
    neuesBild1 = matrix1.catMappen(); 
    image(neuesBild1,0,0); save("data/textV1.png");
   
    s2 = werteV[4];  t2 = werteV[5];  l2 = werteV[6];   
    matrix2 = new TransMatrix(s2,t2,neuesBild1,l2,N);
    neuesBild2 = matrix2.catMappen(); 
    image(neuesBild2,0,0); save("data/textV2.png");
    
    s3 = werteV[8];  t3 = werteV[9];  l3 = werteV[10];   
    matrix3 = new TransMatrix(s3,t3,neuesBild2,l3,N);
    neuesBild3 = matrix3.catMappen(); 
    image(neuesBild3,0,0); save("data/textV3.png");
    
    s4 = werteV[12];  t4 = werteV[13];  l4 = werteV[14];  
    matrix4= new TransMatrix(s4,t4,neuesBild3,l4,N);
    neuesBild4 = matrix4.catMappen(); 
    image(neuesBild4,0,0); save("data/textV4.png");
    
    //Permutation
     tmpBild = loadImage("data/textV4.png");
     permSchluessel = loadStrings("data/permSchluessel.txt");
     int ax, ay, bx, by;
     color tauschA = color(0,0,0);
     color tauschB = color(0,0,0);
 
    for(int iV = 0; iV<n; iV= iV+4){
        ax = Integer.parseInt(permSchluessel[iV]);
        ay = Integer.parseInt(permSchluessel[iV+1]);
        bx = Integer.parseInt(permSchluessel[iV+2]);
        by = Integer.parseInt(permSchluessel[iV+3]);
        tauschA = tmpBild.get(ax,ay);
        tauschB = tmpBild.get(bx,by);
        tmpBild.set(ax,ay,tauschB) ;
        tmpBild.set(bx,by,tauschA) ;
    }
 
   tmpBild.save("data/textVerschluesselt.png");
   bild = loadImage("data/textVerschluesselt.png");
   image(bild,0,0);
    println("Verschlüsselung beendet!");
  }
  
  
  if(key == 'e'){//entschlüsseln in vier Schritten in umgekehrter Reihenfolge
   println("Entschlüsselung startet!");
   //Permutation rückgängig machen
   int ax, ay, bx, by;
   permSchluessel = loadStrings("permSchluessel.txt");
   tmpBild = loadImage("textVerschluesselt.png");   
   color tauschA = color(0,0,0);
   color tauschB = color(0,0,0);
  
   for(int i = 0; i<n; i= i+4){
      ax = Integer.parseInt(permSchluessel[n-2-i]);
      ay = Integer.parseInt(permSchluessel[n-1-i]);
      bx = Integer.parseInt(permSchluessel[n-4-i]);
      by = Integer.parseInt(permSchluessel[n-3-i]);
      tauschA = tmpBild.get(ax,ay);
      tauschB = tmpBild.get(bx,by);
      tmpBild.set(ax,ay,tauschB) ;
      tmpBild.set(bx,by,tauschA) ;
    }
    tmpBild.save("data/textTeilEntschluesselt.png");
    
    schluesselV = loadTable("schluesselV.csv", "header");//Schlüssel auslesen
    bildV = loadImage("textTeilEntschluesselt.png");   
    werteV = new int[schluesselV.getRowCount()];
    int i =0;
    for (TableRow row : schluesselV.rows()) {  
        int id = row.getInt("zahl");
        werteV[i] = id;
        i++;
    }
   //AT entschlüsseln in vier Schritten in umgekehrter Reihenfolge
    s1 = werteV[12];  t1 = werteV[13];  l1 =werteV[15]- werteV[14];  //P-l 
    matrix5 = new TransMatrix(s1,t1,bildV,l1,N);
    neuesBild5 = matrix5.catMappen(); 
    image(neuesBild5,0,0); save("data/textE1.png");
   
    s2 = werteV[8];  t2 = werteV[9];  l2 = werteV[11]- werteV[10];   
    matrix6 = new TransMatrix(s2,t2,neuesBild5,l2,N);
    neuesBild6 = matrix6.catMappen(); 
    image(neuesBild6,0,0); save("data/textE2.png");
    
    s3 = werteV[4];  t3 = werteV[5];  l3 = werteV[7]- werteV[6];   
    matrix7 = new TransMatrix(s3,t3,neuesBild6,l3,N);
    neuesBild7 = matrix7.catMappen(); 
    image(neuesBild7,0,0); save("data/textE3.png");
    
    s4 = werteV[0];  t4 = werteV[1];  l4 = werteV[3]- werteV[2];  
    matrix8 = new TransMatrix(s4,t4,neuesBild7,l4,N);
    neuesBild8 = matrix8.catMappen();
    image(neuesBild8,0,0); save("data/textEntschluesselt.png");
    
     println("Entschlüsselung beendet!");
  }
  
  if(key == 'k'){//pseudo-zufällige Schlüssel erzeugen
      println("Die Berechnung der Schlüssel kann einige Sekunden dauern!");
      s1 =randomGen.nextInt(N);t1 =randomGen.nextInt(N);l1 = 2;//l-Werte nur vorläufig
      s2 =randomGen.nextInt(N);t2 =randomGen.nextInt(N);l2 = 2;
      s3 =randomGen.nextInt(N);t3 =randomGen.nextInt(N);l3 = 2;
      s4 =randomGen.nextInt(N);t4 =randomGen.nextInt(N);l4 = 2;
      schluesselV.setInt(0,  "zahl", s1);
      schluesselV.setInt(1,  "zahl", t1);
      schluesselV.setInt(2,  "zahl", l1);
      schluesselV.setInt(3,  "zahl", P1);
      schluesselV.setInt(4,  "zahl", s2);
      schluesselV.setInt(5,  "zahl", t2);
      schluesselV.setInt(6,  "zahl", l2);
      schluesselV.setInt(7,  "zahl", P2);
      schluesselV.setInt(8,  "zahl", s3);
      schluesselV.setInt(9,  "zahl", t3);
      schluesselV.setInt(10, "zahl", l3);
      schluesselV.setInt(11, "zahl", P3);
      schluesselV.setInt(12, "zahl", s4);
      schluesselV.setInt(13, "zahl", t4);
      schluesselV.setInt(14, "zahl", l4);
      schluesselV.setInt(15, "zahl", P4); 
      werteV = new int[schluesselV.getRowCount()];
      int i =0;
      for (TableRow row : schluesselV.rows()) {  
          int id = row.getInt("zahl");
          werteV[i] = id;
          i++;
      }
       
      s1 = werteV[0];  t1 = werteV[1];  l1 = werteV[2];  
      matrix1 = new TransMatrix(s1,t1,bild1,l1,N); 
      s2 = werteV[4];  t2 = werteV[5];  l2 = werteV[6];  
      matrix2 = new TransMatrix(s2,t2,neuesBild1,l2,N);   
      s3 = werteV[8];  t3 = werteV[9];  l3 = werteV[10];   
      matrix3 = new TransMatrix(s3,t3,neuesBild2,l3,N);   
      s4 = werteV[12];  t4 = werteV[13];  l4 = werteV[14];  
      matrix4= new TransMatrix(s4,t4,neuesBild3,l4,N);
   
    
     ArrayList<WorkThread> workers = new ArrayList<WorkThread>();//Multithreading
      //Perioden müssen bestimmt werden, damit die Anzahl der jeweiligen Transformationen bestimmt werden kann.
      workers.add(new WorkThread(0,matrix1,bild1)); //Wurde als Anzahl der Transformation z. B. 323 angegeben,
      workers.add(new WorkThread(1,matrix2,bild2)); //und die zugehörige Periode ist 200, dann muss die Transformation
      workers.add(new WorkThread(2,matrix3,bild3)); //bei der Verschlüsselung nur 123 mal, und
      workers.add(new WorkThread(3,matrix4,bild4)); //bei der Entschlüsselung 200-123 = 77 mal angewand werden.
          
       for (WorkThread worker : workers) {   
        while (worker.running)
        {
          try{
          Thread.sleep(10);  
          }catch (Exception e) {  }  ;                
        }
      }    
          
      P1= workers.get(0).P1; l1= 1+randomGen.nextInt(P1-3); l1E=P1-l1;//Anzahl der jeweiligen Transformationen festlegen
      P2= workers.get(1).P2; l2= 1+randomGen.nextInt(P2-3); l2E=P2-l2;
      P3= workers.get(2).P3; l3= 1+randomGen.nextInt(P3-3); l3E=P3-l3;
      P4= workers.get(3).P4; l4= 1+randomGen.nextInt(P4-3); l4E=P4-l4;
      println("Die Perioden sind: "+P1,P2,P3,P4);//Nur zur Information 
      println("Die Schlüssel sind: ");
      println(s1,t1,l1+"    "+s2,t2,l2+"    "+s3,t3,l3+"    "+s4,t4,l4);//Nur zur Information
      println(s4,t4,l4E+"    "+s3,t3,l3E+"    "+s2,t2,l2E+"    "+s1,t1,l1E);//Nur zur Information
      println("In Ordner data als <schluesselV.csv> und <schluesselE.csv> abgelegt");
         
      schluesselV.setInt(2, "zahl",  l1);    //korrigierte Werte
      schluesselV.setInt(3, "zahl",  P1); 
      schluesselV.setInt(6, "zahl",  l2);    
      schluesselV.setInt(7, "zahl",  P2); 
      schluesselV.setInt(10, "zahl", l3);   
      schluesselV.setInt(11, "zahl", P3); 
      schluesselV.setInt(14, "zahl", l4);
      schluesselV.setInt(15, "zahl", P4); 
      
      saveTable(schluesselV, "data/schluesselV.csv");  
     
     
       permSchluessel = new String[n];//Permutationsschlüssel
       for (int iP = 0; iP < n; iP ++ ) {
          permSchluessel[iP] = str(randomGen.nextInt(N));    
       }
       saveStrings("data/permSchluessel.txt", permSchluessel);
       println("Schlüssel berechnet.");
       println("Drücken Sie nun die Taste <v> zum Verschlüsseln des Textes!");
  }
}